/*
*  Rubrica
*  file: addressbook.h
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __RUBRICA_ADDRESSBOOK_H
#define __RUBRICA_ADDRESSBOOK_H

#include <gnome.h>

#include "rubrica.h"

#define RUBRICA_IS_ADDRESSBOOK_PAGE(x)  if ((x) < 0 || (x) > addressbook->pages)\
                                           return NULL;

typedef struct _RubricaAddressBook   RubricaAddressBook;

struct _RubricaAddressBook
{
  GList *book;            /* lista di elementi AddressBook */
  
  /* il notebook */
  GtkWidget *notebook;
  
  gint pages;             /* pagine totali */
  gint current;           /* pagina attuale */
};


void rubrica_addressbook_new(void);

RubricaAddressBook *rubrica_get_addressbook(void);

void rubrica_addressbook_init(void); 
void rubrica_addressbook_destroy(void);


gint rubrica_addressbook_add_page(gchar *filename);
GtkWidget *rubrica_addressbook_new_view(GtkWidget **clst);
void rubrica_addressbook_init_view(void);


void rubrica_addressbook_make_this_rubrica_current(Rubrica *r);
void rubrica_addressbook_make_this_page_current(gint page);


void rubrica_addressbook_append_rubrica(Rubrica *r);

/*    get methods that work on RubricaAddressBook struct 
*/
Rubrica *rubrica_addressbook_get_rubrica(gint page);
GtkWidget *rubrica_addressbook_get_notebook(void);
inline gint rubrica_addressbook_get_pages(void);
inline gint rubrica_addressbook_get_current_page(void);

/* ************************
   ************************ */

void rubrica_addressbook_get_path_and_name(gchar **path, gchar **name, gint page);

/*    set methods that work on RubricaAddressBook struct 
*/
inline void rubrica_addressbook_set_pages(gint n);
inline void rubrica_addressbook_set_current_page(gint n);
inline void rubrica_addressbook_inc_pages(void);
inline void rubrica_addressbook_dec_pages(void);


void rubrica_addressbook_set_info(GList *rub, gboolean new, gboolean mod, gboolean emp,
				  gchar *name, gchar *path, 
				  GtkWidget *child, GtkWidget *clist, GtkWidget *label,
				  gint riga, gint colonna,  
				  gboolean rub_flag, gboolean flags_flag,
				  gboolean name_flag, gboolean widget_flag, 
				  gboolean xy_flag, gint pos);


void rubrica_addressbook_set_widget_info(GtkWidget *child, GtkWidget * clist, 
					 GtkWidget *label, gint page);
void rubrica_addressbook_set_label_text(gchar *str, gint page);
void rubrica_addressbook_set_path_and_name(gchar *path, gchar *name, gint page);
void rubrica_addressbook_set_path(gchar *str, gint page);
void rubrica_addressbook_set_name(gchar *str, gint page);
void rubrica_addressbook_set_rubrica(GList *rub, gint page);

void rubrica_addressbook_set_row(gint riga, gint page);
void rubrica_addressbook_set_column(gint column, gint page);
void rubrica_addressbook_set_row_and_column(gint riga, gint colonna, gint page);

void rubrica_addressbook_set_flags(gboolean new, gboolean empty, gboolean modified, 
				   gint page);
void rubrica_addressbook_set_flag(gboolean value, gboolean is_new, gboolean is_empty,
				  gboolean is_modified, gint page);
void rubrica_addressbook_set_rubrica_and_flags(GList *rub, gboolean new, 
					       gboolean empty, gboolean modif,
					       gint page);

/* **************************************************************** */

gboolean rubrica_addressbook_heve_modified();

void rubrica_addressbook_close(void);

#endif








