/*
*  Rubrica
*  file: main.c
*
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <gconf/gconf-client.h>

#include "rubrica.h"
#include "interface.h"
#include "support.h"
#include "main.h"
#include "druid.h"
#include "callbacks.h"
#include "prefer.h"
#include "file.h"
#include "view.h"
#include "dictionary.h"
#include "addressbook.h"

GtkWidget *app;               /* main application window */
GConfClient *client;          /* GConf client            */
gboolean first_run;


GtkWidget *rubrica_get_app(void)
{
  return GTK_WIDGET(app);
}

GConfClient *rubrica_get_client()
{
  return (GConfClient *) client;
}

void rubrica_begin(void)
{
  gchar *fname = NULL;

  rubrica_init(client, first_run);
  app = create_app(client);
  
  
  if (rubrica_start_with_user_addressbook(client) && !first_run)
    {  
      fname = rubrica_get_filename(client);
      rubrica_file_start_with_file(fname);
      
      g_free(fname);
    }
  else
    rubrica_addressbook_add_page(NULL);
  
  gtk_widget_show(app);
}


int
main (int argc, char *argv[])
{
  GError *error = NULL;

  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain (PACKAGE);

  gnome_init ("rubrica", VERSION, argc, argv);

  if (!gconf_init(argc, argv, &error))
    {
      g_warning("GConf init failed:\n %s", error->message);

      g_error_free(error);
      error = NULL;
      return 1;
    }
  client = gconf_client_get_default();

  if ((first_run = rubrica_run_first_time()))
    {
       GtkWidget *druid;
              
       druid = rubrica_druid_create_druid();
       gtk_widget_show (druid);      
    }
  else
    rubrica_begin();

  gtk_main ();

  gtk_object_unref(GTK_OBJECT(client));

  g_print("\n");

  return 0;
}



