/*
*  Rubrica
*  file: modulo_cb.c
*
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <gnome.h>
#include <string.h>

#include "modulo.h"
#include "modulo_cb.h"
#include "modulo_int.h"


void on_check_birthday_toggled(GtkToggleButton *togglebutton, gpointer user_data)
{
  gboolean bool;

  bool = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(togglebutton));

  if (bool)
    gtk_widget_set_sensitive(GTK_WIDGET(user_data), TRUE);
  else
    gtk_widget_set_sensitive(GTK_WIDGET(user_data), FALSE);   
}

/*
void
on_check_cancellabile_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

}


void
on_check_modificabile_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{

}
*/

void on_web_entry_activate(GtkEditable *editable, gpointer  user_data)
{  
  gtk_signal_emit_by_name(GTK_OBJECT(user_data), "clicked");
}


void
on_bot_web_aggiungi_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  ModuloRubrica *modulo = user_data;
  GtkEntry *web_entry;
  GtkCList *web_clist;
  GtkWidget *modifica, *cancella;
  gchar *buffer[3];

  g_return_if_fail(modulo != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(modulo));

  buffer[0] = "";
  buffer[2] = NULL;

  web_entry = GTK_ENTRY(gtk_object_get_data(GTK_OBJECT(modulo), "web_entry"));
  web_clist = GTK_CLIST(gtk_object_get_data(GTK_OBJECT(modulo), "web_clist"));
  modifica  = gtk_object_get_data(GTK_OBJECT(modulo), "web_modify");
  cancella  = gtk_object_get_data(GTK_OBJECT(modulo), "web_delete");

  gtk_widget_set_sensitive(GTK_WIDGET(modifica), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(cancella), FALSE);

  buffer[1] = gtk_entry_get_text(GTK_ENTRY(web_entry));
  gtk_clist_append(web_clist, buffer);
  gtk_entry_set_text(GTK_ENTRY(web_entry),"");
}


void
on_bot_web_modifica_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  ModuloRubrica *modulo = user_data;
  GtkWidget *web_entry;
  GtkWidget *web_clist;
  GtkWidget *modifica, *cancella;
  gchar *buffer;
  
  g_return_if_fail(modulo != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(modulo));
 
  /* click sul bottone modifica, allora l'entry contiene il
     valore da sostituire a quello corrente.
     Prendo il valore e lo sostituisco nella lista
  */
  web_entry = gtk_object_get_data(GTK_OBJECT(modulo), "web_entry");
  web_clist = gtk_object_get_data(GTK_OBJECT(modulo), "web_clist");
  modifica  = gtk_object_get_data(GTK_OBJECT(modulo), "web_modify");
  cancella  = gtk_object_get_data(GTK_OBJECT(modulo), "web_delete");
  
  buffer = gtk_entry_get_text(GTK_ENTRY(web_entry));
  gtk_clist_set_text(GTK_CLIST(web_clist), modulo->webinfo.riga, 1, buffer);

  /* Pulisco l'entry, annullo il flag che memorizza la selezione della riga
     elimino la selezione della riga e rendo insensibile i bottoni
  */  
  modulo->webinfo.selezionato = FALSE;
  gtk_entry_set_text(GTK_ENTRY(web_entry),"");
  gtk_widget_set_sensitive(GTK_WIDGET(modifica), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(cancella), FALSE);  

}


void
on_bot_web_elimina_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  ModuloRubrica *modulo = user_data;
  GtkWidget *web_entry;
  GtkWidget *web_clist;
  GtkWidget *modifica, *cancella;

  g_return_if_fail(modulo != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(modulo));
  
  web_entry = gtk_object_get_data(GTK_OBJECT(modulo), "web_entry");
  web_clist = gtk_object_get_data(GTK_OBJECT(modulo), "web_clist");
  modifica  = gtk_object_get_data(GTK_OBJECT(modulo), "web_modify");
  cancella  = gtk_object_get_data(GTK_OBJECT(modulo), "web_delete");

  gtk_clist_remove(GTK_CLIST(web_clist), modulo->webinfo.riga);

  modulo->webinfo.selezionato = FALSE;
  gtk_entry_set_text(GTK_ENTRY(web_entry), "");
  gtk_widget_set_sensitive(GTK_WIDGET(modifica), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(cancella), FALSE);  
}


void
on_web_clist_select_row        (GtkCList        *clist,
				gint             row,
				gint             column,
				GdkEvent        *event,
				gpointer         user_data)
{
  ModuloRubrica *modulo = user_data;
  GtkWidget *web_entry;
  GtkWidget *modifica, *cancella;
  gchar *buffer;

  g_return_if_fail(modulo != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(modulo));
  g_return_if_fail(GTK_IS_CLIST(clist));

  /*  stato selezionato un elemento della lista bisogna 
     sensibilizzare i bottoni modifica (e cancella) per permettere
     all'utente di operare la selezione voluta   

     Prelevo il contenuto della riga selezionata e lo rendo 
     disponibile nell' entry per l'eventuale modifica
  */
  web_entry = gtk_object_get_data(GTK_OBJECT(modulo), "web_entry");
  modifica  = gtk_object_get_data(GTK_OBJECT(modulo), "web_modify");
  cancella  = gtk_object_get_data(GTK_OBJECT(modulo), "web_delete");

  gtk_clist_get_text(GTK_CLIST(clist), row, 1, &buffer);
  gtk_entry_set_text(GTK_ENTRY(web_entry), buffer);
  gtk_widget_set_sensitive(GTK_WIDGET(modifica), TRUE);

  /* un solo click 
     l'utente pu modificare o cancellare l'elemento selezionato
     sensibilizzo modifica e cancella
  */
  if (event->type == GDK_BUTTON_RELEASE){
    modulo->webinfo.riga = row;
    modulo->webinfo.colonna = column;
    modulo->webinfo.selezionato = TRUE;    
    gtk_widget_set_sensitive(GTK_WIDGET(cancella), TRUE);

    return;
  }
  
  /* doppio click
     l'utente deve modificare l'elemento selezionato
     sensibilizzo solo il bottone modifica
  */
  if(event->type == GDK_2BUTTON_PRESS){
    modulo->webinfo.riga = row;
    modulo->webinfo.colonna = column;
    modulo->webinfo.selezionato = TRUE;     

    return;
  }
}


void on_email_entry_activate(GtkEditable *editable, gpointer  user_data)
{
  gtk_signal_emit_by_name(GTK_OBJECT(user_data), "clicked");
}

void
on_bot_mail_aggiungi_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  ModuloRubrica *modulo = user_data;
  GtkEntry *email_entry;
  GtkCList *email_clist;
  GtkWidget *modifica, *cancella;
  gchar *buffer[3];

  g_return_if_fail(modulo != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(modulo));

  buffer[0] = "";
  buffer[2] = NULL;

  email_entry = GTK_ENTRY(gtk_object_get_data(GTK_OBJECT(modulo), "email_entry"));
  email_clist = GTK_CLIST(gtk_object_get_data(GTK_OBJECT(modulo), "email_clist"));
  modifica  = gtk_object_get_data(GTK_OBJECT(modulo), "email_modify");
  cancella  = gtk_object_get_data(GTK_OBJECT(modulo), "email_delete");

  gtk_widget_set_sensitive(GTK_WIDGET(modifica), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(cancella), FALSE);

  buffer[1] = gtk_entry_get_text(GTK_ENTRY(email_entry));
  gtk_clist_append(email_clist,buffer);
  gtk_entry_set_text(GTK_ENTRY(email_entry),"");
}


void
on_bot_mail_modifica_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  ModuloRubrica *modulo = user_data;
  GtkEntry *email_entry;
  GtkCList *email_clist;
  GtkWidget *modifica, *cancella;
  gchar *buffer;
  
  g_return_if_fail(modulo != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(modulo));

  email_entry = GTK_ENTRY(gtk_object_get_data(GTK_OBJECT(modulo), "email_entry"));
  email_clist = GTK_CLIST(gtk_object_get_data(GTK_OBJECT(modulo), "email_clist"));
  modifica  = gtk_object_get_data(GTK_OBJECT(modulo), "email_modify");
  cancella  = gtk_object_get_data(GTK_OBJECT(modulo), "email_delete");

  buffer = gtk_entry_get_text(GTK_ENTRY(email_entry));
  gtk_clist_set_text(GTK_CLIST(email_clist), modulo->mailinfo.riga, 1, buffer);

  modulo->mailinfo.selezionato = FALSE;
  gtk_entry_set_text(GTK_ENTRY(email_entry),"");
  gtk_widget_set_sensitive(GTK_WIDGET(modifica), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(cancella), FALSE);  
}


void
on_bot_mail_elimina_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  ModuloRubrica *modulo = user_data;
  GtkEntry *email_entry;
  GtkCList *email_clist;
  GtkWidget *modifica, *cancella;

  g_return_if_fail(modulo != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(modulo));
  
  email_entry = GTK_ENTRY(gtk_object_get_data(GTK_OBJECT(modulo), "email_entry"));
  email_clist = GTK_CLIST(gtk_object_get_data(GTK_OBJECT(modulo), "email_clist"));
  modifica  = gtk_object_get_data(GTK_OBJECT(modulo), "email_modify");
  cancella  = gtk_object_get_data(GTK_OBJECT(modulo), "email_delete");

  modulo->mailinfo.selezionato = FALSE;
  gtk_clist_remove(GTK_CLIST(email_clist), modulo->mailinfo.riga);
  gtk_entry_set_text(GTK_ENTRY(email_entry), "");
  gtk_widget_set_sensitive(GTK_WIDGET(modifica), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(cancella), FALSE);  
}


void
on_mail_clist_select_row       (GtkCList        *clist,
				gint             row,
				gint             column,
				GdkEvent        *event,
				gpointer         user_data)
{
  ModuloRubrica *modulo = user_data;
  GtkEntry *email_entry;
  GtkCList *email_clist;
  GtkWidget *modifica, *cancella;
  gchar *buffer;

  g_return_if_fail(modulo != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(modulo));
  g_return_if_fail(GTK_IS_CLIST(clist));

  email_entry = GTK_ENTRY(gtk_object_get_data(GTK_OBJECT(modulo), "email_entry"));
  email_clist = GTK_CLIST(gtk_object_get_data(GTK_OBJECT(modulo), "email_clist"));

  modifica  = gtk_object_get_data(GTK_OBJECT(modulo), "email_modify");
  cancella  = gtk_object_get_data(GTK_OBJECT(modulo), "email_delete");

  gtk_clist_get_text(GTK_CLIST(clist), row, 1, &buffer);
  gtk_entry_set_text(GTK_ENTRY(email_entry), buffer);
  gtk_widget_set_sensitive(GTK_WIDGET(modifica), TRUE);

  if (event->type == GDK_BUTTON_RELEASE){
    modulo->mailinfo.riga = row;
    modulo->mailinfo.colonna = column;
    modulo->mailinfo.selezionato = TRUE;    
    gtk_widget_set_sensitive(GTK_WIDGET(cancella), TRUE);

    return;
  }
  
  if(event->type == GDK_2BUTTON_PRESS){
    modulo->mailinfo.riga = row;
    modulo->mailinfo.colonna = column;
    modulo->mailinfo.selezionato = TRUE;     

    return;
  }    
}


void
on_radio_casa_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  modulo_rubrica_set_telefono_attivo("home");
}

void
on_radio_ufficio_toggled                (GtkToggleButton *togglebutton,
					 gpointer         user_data)
{
  modulo_rubrica_set_telefono_attivo("work");
}


void
on_radio_fax_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  modulo_rubrica_set_telefono_attivo("fax");
}


void
on_radio_cellulare_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  modulo_rubrica_set_telefono_attivo("cellphone");
}

void
on_radio_altro_toggled             (GtkToggleButton *togglebutton,
				    gpointer         user_data)
{
  modulo_rubrica_set_telefono_attivo("other");
}


void
on_telefono_clist_select_row   (GtkCList        *clist,
				gint             row,
				gint             column,
				GdkEvent        *event,
				gpointer         user_data)
{
  ModuloRubrica *modulo = user_data;
  GtkWidget *telephone_entry;
  GtkWidget *modifica, *cancella;
  GtkWidget *radio_casa, *radio_ufficio;
  GtkWidget *radio_fax, *radio_cellulare, *radio_altro;
  gchar *buffer[2];
  gint tipo;

  g_return_if_fail(modulo != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(modulo));
  g_return_if_fail(GTK_IS_CLIST(clist));

  gtk_clist_get_text(GTK_CLIST(clist), row, 1, &buffer[0]);
  gtk_clist_get_text(GTK_CLIST(clist), row, 2, &buffer[1]);

  telephone_entry = gtk_object_get_data(GTK_OBJECT(modulo), "number_entry");
  radio_casa      = gtk_object_get_data(GTK_OBJECT(modulo), "home_radio");
  radio_ufficio   = gtk_object_get_data(GTK_OBJECT(modulo), "work_radio"); 
  radio_fax       = gtk_object_get_data(GTK_OBJECT(modulo), "fax_radio");
  radio_cellulare = gtk_object_get_data(GTK_OBJECT(modulo), "cell_radio");
  radio_altro     = gtk_object_get_data(GTK_OBJECT(modulo), "other_radio");
  modifica        = gtk_object_get_data(GTK_OBJECT(modulo), "tel_modify");
  cancella        = gtk_object_get_data(GTK_OBJECT(modulo), "tel_delete");
  
  gtk_entry_set_text(GTK_ENTRY(telephone_entry), buffer[0]);
  tipo = modulo_rubrica_tipo_telefono_int(buffer[1]);
  switch (tipo)
    {
    case TELEPHONE_HOME:
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio_casa), TRUE);
      break;
    case TELEPHONE_WORK:
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio_ufficio), TRUE);
      break;
    case TELEPHONE_FAX:
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio_fax), TRUE);
      break;
    case TELEPHONE_CELLPHONE:
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio_cellulare), TRUE);
      break; 
    case TELEPHONE_OTHER:
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio_altro), TRUE);
      break; 
    default:
      break;
    }
 
  gtk_widget_set_sensitive(GTK_WIDGET(modifica), TRUE);

  /* un solo click
   */
  if (event->type == GDK_BUTTON_RELEASE){
    modulo->telinfo.riga = row;
    modulo->telinfo.colonna = column;
    modulo->telinfo.selezionato = TRUE;    
    gtk_widget_set_sensitive(GTK_WIDGET(cancella), TRUE);

    return;
  }
  
  /* doppio click
   */
  if(event->type == GDK_2BUTTON_PRESS){
    modulo->telinfo.riga = row;
    modulo->telinfo.colonna = column;
    modulo->telinfo.selezionato = TRUE;     

    return;
  }
}

void on_tel_entry_activate(GtkEditable *editable, gpointer  user_data)
{
  gtk_signal_emit_by_name(GTK_OBJECT(user_data), "clicked");
}

void
on_bot_tel_aggiungi_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  ModuloRubrica *modulo = user_data;
  GtkEntry *telephone_entry;
  GtkCList *telephone_clist;
  GtkWidget *modifica, *cancella;
  gchar *buffer[4];

  g_return_if_fail(modulo != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(modulo));

  telephone_entry = gtk_object_get_data(GTK_OBJECT(modulo), "number_entry");
  telephone_clist = gtk_object_get_data(GTK_OBJECT(modulo), "telephone_clist"); 
  modifica        = gtk_object_get_data(GTK_OBJECT(modulo), "tel_modify");
  cancella        = gtk_object_get_data(GTK_OBJECT(modulo), "tel_delete");

  gtk_widget_set_sensitive(GTK_WIDGET(modifica), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(cancella), FALSE);

  buffer[0] = "";        // eventuale pixmap
  buffer[1] = gtk_entry_get_text(GTK_ENTRY(telephone_entry));
  buffer[2] = modulo_rubrica_get_telefono_attivo();
  buffer[3] = NULL;      // file della lista

  gtk_clist_append(telephone_clist,buffer);
  gtk_entry_set_text(GTK_ENTRY(telephone_entry),"");
}


void
on_bot_tel_modifica_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  ModuloRubrica *modulo = user_data;
  GtkEntry *telephone_entry;
  GtkCList *telephone_clist;
  GtkWidget *modifica, *cancella;
  gchar *buffer[2];
  
  g_return_if_fail(modulo != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(modulo));

  telephone_entry = gtk_object_get_data(GTK_OBJECT(modulo), "number_entry");
  telephone_clist = gtk_object_get_data(GTK_OBJECT(modulo), "telephone_clist"); 
  modifica        = gtk_object_get_data(GTK_OBJECT(modulo), "tel_modify");
  cancella        = gtk_object_get_data(GTK_OBJECT(modulo), "tel_delete");
 
  buffer[0] = gtk_entry_get_text(GTK_ENTRY(telephone_entry));
  buffer[1] = modulo_rubrica_get_telefono_attivo();

  gtk_clist_set_text(GTK_CLIST(telephone_clist), modulo->telinfo.riga, 1, buffer[0]);
  gtk_clist_set_text(GTK_CLIST(telephone_clist), modulo->telinfo.riga, 2, buffer[1]);

  gtk_entry_set_text(GTK_ENTRY(telephone_entry),"");

  modulo->telinfo.selezionato = FALSE;
  gtk_widget_set_sensitive(GTK_WIDGET(modifica), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(cancella), FALSE);  
}


void
on_bot_tel_elimina_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  ModuloRubrica *modulo = user_data;
  GtkCList *telephone_clist;
  GtkWidget *modifica, *cancella;

  g_return_if_fail(modulo != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(modulo));

  telephone_clist = gtk_object_get_data(GTK_OBJECT(modulo), "telephone_clist"); 
  modifica        = gtk_object_get_data(GTK_OBJECT(modulo), "tel_modify");
  cancella        = gtk_object_get_data(GTK_OBJECT(modulo), "tel_delete");
  
  gtk_clist_remove(GTK_CLIST(telephone_clist), modulo->telinfo.riga);

  modulo->telinfo.selezionato = FALSE;
  gtk_widget_set_sensitive(GTK_WIDGET(modifica), FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(cancella), FALSE);  
}

void on_radio_married_toggled (GtkButton *button,  gpointer user_data)
{
  ModuloRubrica *modulo = user_data;
  GtkWidget *spouse;
  GtkWidget *birthday;
  GtkWidget *anniversary; 
  gboolean bool;

  g_return_if_fail(modulo != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(modulo));  
  
  spouse      = gtk_object_get_data(GTK_OBJECT(modulo), "spouse_entry");
  birthday    = gtk_object_get_data(GTK_OBJECT(modulo), "spouse_birthday");
  anniversary = gtk_object_get_data(GTK_OBJECT(modulo), "anniversary");

  bool = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button));

  gtk_widget_set_sensitive(spouse, bool);
  gtk_widget_set_sensitive(birthday, bool);
  gtk_widget_set_sensitive(anniversary, bool); 
}


void on_radio_children_toggled (GtkButton *button,  gpointer user_data)
{
  ModuloRubrica *modulo = user_data;
  GtkWidget *children;
  gboolean bool;

  g_return_if_fail(modulo != NULL);
  g_return_if_fail(IS_MODULO_RUBRICA(modulo)); 

  children = gtk_object_get_data(GTK_OBJECT(modulo), "children_text");
  bool   = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button));

  gtk_widget_set_sensitive(children, bool);
}







