#include <gnome.h>
#include <gconf/gconf-client.h>

#include "prefer.h"
#include "prefer-notify.h"

guint rubrica_config_path_notify(GtkWidget *label, GConfClient *client, gchar *key)
{
  GConfValue *show_path = NULL;  
  gchar *str;

  guint notify_id;

  show_path = gconf_client_get(client, key, NULL);  

  if (show_path != NULL && 
      show_path->type == GCONF_VALUE_BOOL &&
      gconf_value_get_bool(show_path))
    {          
      GConfValue *book = NULL; 
      
      book = gconf_client_get(client, RUBRICA_KEY_LAST_BOOK, NULL);
      
      if (book != NULL && book->type == GCONF_VALUE_STRING)
	{		  	  
	  str = g_dirname(gconf_value_get_string(book));
	  
	  gtk_label_set_text(GTK_LABEL(label), str);
	  
	  g_free(str);	      
	}
    }    
  else    
    gtk_label_set_text(GTK_LABEL(label), "");
  
  notify_id = gconf_client_notify_add(client, key, rubrica_path_change_notify, 
				      label, NULL, NULL);
  
  gtk_object_set_data(GTK_OBJECT(client), "show_path_notify", 
		      GUINT_TO_POINTER(notify_id));
  
  return (guint) notify_id;
}

void rubrica_path_change_notify(GConfClient * client, guint cnxn_id, 
				GConfEntry *entry, gpointer data)
{  
  if (entry->value != NULL && 
      entry->value->type == GCONF_VALUE_BOOL &&
      gconf_value_get_bool(entry->value))
    {     
      GConfValue *book = NULL; 
      gchar *str;

      book = gconf_client_get(client, RUBRICA_KEY_LAST_BOOK, NULL);
      
      if (book != NULL && book->type == GCONF_VALUE_STRING)
	{		  	  
	  str = g_dirname(gconf_value_get_string(book));
	  
	  gtk_label_set_text(GTK_LABEL(data), str);
	  
	  g_free(str);	      
	}
    }
  else
    gtk_label_set_text(GTK_LABEL(data), "");  
}


guint rubrica_config_check_notify(GtkWidget *check, GConfClient *client, gchar *key)
{
  GConfValue *checkval = NULL;  

  guint notify_id;

  checkval = gconf_client_get(client, key, NULL);  

  if (checkval != NULL && 
      checkval->type == GCONF_VALUE_BOOL &&
      gconf_value_get_bool(checkval))
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), TRUE);              
  else    
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), FALSE);              
  
  notify_id = gconf_client_notify_add(client, key, rubrica_check_change_notify, 
				      check, NULL, NULL);
  
  if (strcmp(key, RUBRICA_KEY_SENSITIVE) == 0)
    gtk_object_set_data(GTK_OBJECT(client), "check_sensitive", 
			GUINT_TO_POINTER(notify_id));
  else
    gtk_object_set_data(GTK_OBJECT(client), "check_incomplete", 
			GUINT_TO_POINTER(notify_id));     
  return (guint) notify_id;
}

void rubrica_check_change_notify(GConfClient * client, guint cnxn_id, 
				 GConfEntry *entry, gpointer data)
{  
  GtkWidget *check = data;

  if (entry->value != NULL && 
      entry->value->type == GCONF_VALUE_BOOL)      
    {
      gboolean bool;

      bool = gconf_value_get_bool(entry->value);
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), bool);
    }
}
































