/*
*  Rubrica
*  file: search_cb.c
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "search.h"
#include "search_cb.h"
#include "search_int.h"
#include "prefer.h"


void
on_radio_card_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  rubrica_search_where_set(CARD);
}


void
on_radio_name_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
    rubrica_search_where_set(NAME);
}


void
on_radio_surname_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  rubrica_search_where_set(SURNAME);
}


void
on_radio_state_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  rubrica_search_where_set(STATE);
}


void
on_radio_city_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  rubrica_search_where_set(CITY);
}


void
on_radio_prof_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  rubrica_search_where_set(PROF);
}


void
on_radio_web_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  rubrica_search_where_set(WEB);
}


void
on_radio_mail_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  rubrica_search_where_set(MAIL);
}


void
on_radio_tel_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  rubrica_search_where_set(TEL);
}


void
on_case_check_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  gboolean bool;
  
  bool = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(togglebutton));
  if (bool)
    /* ricerca case sensitive */
    rubrica_search_sensitive_set(CASE_SENSITIVE);
  else 
    /* ricerca not case sensitive */
    rubrica_search_sensitive_set(CASE_INSENSITIVE);      

  rubrica_preferences_set_case_sensitive_search(bool);
}

void
on_incomplete_check_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  gboolean bool;

  bool = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(togglebutton));

  if (bool)
    /* search a string in another string */
    rubrica_search_into_set(PARTIAL_MATCH);   
  else 
    /* ricerca su tutta la stringa */
    rubrica_search_into_set(FULL_MATCH);   

  rubrica_preferences_set_incomplete_search(bool);
  rubrica_preferences_set_complete_search(!bool); 
}

void
on_search_list_select_row              (GtkCList *clist, gint row, gint column, 
					GdkEvent *event, gpointer  user_data)
{
  gint pos;
  GtkVisibility visible;
  
  pos = GPOINTER_TO_INT(gtk_clist_get_row_data(GTK_CLIST(clist), row));

  rubrica_scheda_ennesima(pos);

  visible = gtk_clist_row_is_visible(GTK_CLIST(clist), row);

  if ((visible == GTK_VISIBILITY_NONE) || 
      (visible == GTK_VISIBILITY_PARTIAL))
    gtk_clist_moveto(GTK_CLIST(clist), row, 0, 0.5, 0); 

//  rubrica_search_view_item(row);
}


gboolean
on_search_list_button_press_event      (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  /* TODO
     intercettare la pressione 
     del tasto destro del mouse */
  /* e mostrare un popup menu */ 
  return FALSE;
}


void
on_search_ok_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{   
  rubrica_search_item();
}


void
on_search_close_clicked                 (GtkButton       *button,
					 gpointer         user_data)
{
  gtk_widget_hide(GTK_WIDGET(user_data));
}

