/*
*  Rubrica
*  file: search_int.c
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/*
 * NON MODIFICARE QUESTO FILE - generato automaticamente da Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gnome.h>
#include <gconf/gconf-client.h>

#include "search.h"
#include "search_cb.h"
#include "search_int.h"
#include "prefer.h"
#include "prefer-notify.h"
#include "main.h"

GtkWidget *search_list;
GtkWidget *search_text;
GtkWidget *text_history;
GtkWidget *label_result;

void rubrica_search_dialog_clean(void)
{
  gtk_clist_clear(GTK_CLIST(search_list));
  gtk_entry_set_text(GTK_ENTRY(search_text), "");
  gtk_label_set_text(GTK_LABEL(label_result), "");
}

GtkWidget*
create_search_dialog (GConfClient *client)
{
  GtkWidget *app;

  GtkWidget *search_dialog;
  GtkWidget *dialog_vbox;

  GSList *search_grp_group = NULL;
  GtkWidget *radio_card;
  GtkWidget *radio_name;
  GtkWidget *radio_surname;
  GtkWidget *radio_state;
  GtkWidget *radio_city;
  GtkWidget *radio_prof;
  GtkWidget *radio_web;
  GtkWidget *radio_mail;
  GtkWidget *radio_tel;

  GtkWidget *case_check;
  GtkWidget *incomplete_check;

  GtkWidget *result_window;

  GtkWidget *label_card;
  GtkWidget *label_other;

  GtkWidget *frame1;
  GtkWidget *frame2;
  GtkWidget *frame3;
  GtkWidget *frame4;
  GtkWidget *frame5;

  GtkWidget *vbox;
  GtkWidget *vbox2;

  GtkWidget *hbox1;
  GtkWidget *hbox2;
  GtkWidget *hbox3;
  GtkWidget *hbox4;

  GtkWidget *label;

  GtkWidget *table;

  GtkWidget *dialog_action_area2;
  GtkWidget *search_button;
  GtkWidget *close_button;

  rubrica_search_init();
  app = rubrica_get_app();
  
  search_dialog = gnome_dialog_new (_("Rubrica search"), NULL);
  gtk_widget_set_name (search_dialog, "search_dialog");
//  gtk_object_set_data (GTK_OBJECT (search_dialog), "search_dialog", search_dialog);
  gtk_object_set_data (GTK_OBJECT (app), "search_dialog", search_dialog);
  gtk_container_set_border_width (GTK_CONTAINER (search_dialog), 5);
  gtk_window_set_position (GTK_WINDOW (search_dialog), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (search_dialog), TRUE, TRUE, FALSE);
  gnome_dialog_close_hides (GNOME_DIALOG (search_dialog), TRUE);

  dialog_vbox = GNOME_DIALOG (search_dialog)->vbox;
  gtk_widget_set_name (dialog_vbox, "dialog_vbox");
  gtk_object_set_data (GTK_OBJECT (search_dialog), "dialog_vbox", dialog_vbox);
  gtk_widget_show (dialog_vbox);

  frame1 = gtk_frame_new (_("Rubrica search"));
  gtk_widget_set_name (frame1, "frame1");
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (search_dialog), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox), frame1, TRUE, TRUE, 0); 
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 3);

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (frame1), vbox);

  frame2 = gtk_frame_new (_(" What "));
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (vbox), frame2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame2), 5);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (frame2), hbox1);

  label = gtk_label_new (_(" Name "));
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox1), label, FALSE, FALSE, 0);
  gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
  gtk_misc_set_padding (GTK_MISC (label), 5, 0);

  text_history = gnome_entry_new ("search_history");
  gtk_object_set_data_full (GTK_OBJECT (search_dialog), "text_history", text_history,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text_history);
  gtk_box_pack_start (GTK_BOX (hbox1), text_history, TRUE, TRUE, 0);

  search_text = gnome_entry_gtk_entry (GNOME_ENTRY (text_history));
  gtk_object_set_data_full (GTK_OBJECT (search_dialog), "search_text", search_text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (search_text);


  frame3 = gtk_frame_new (_(" Where "));
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (vbox), frame3, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame3), 5);

  table = gtk_table_new (3, 3, TRUE);
  gtk_widget_show (table);
  gtk_container_add (GTK_CONTAINER (frame3), table);
  gtk_container_set_border_width (GTK_CONTAINER (table), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table), 5);

  radio_card = gtk_radio_button_new_with_label (search_grp_group, _("Card"));
  search_grp_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_card));
  gtk_widget_set_name (radio_card, "radio_card");
  gtk_widget_ref (radio_card);
  gtk_object_set_data_full (GTK_OBJECT (search_dialog), "radio_card", radio_card,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radio_card);
  gtk_table_attach (GTK_TABLE (table), radio_card, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  radio_name = gtk_radio_button_new_with_label (search_grp_group, _("First Name"));
  search_grp_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_name));
  gtk_widget_set_name (radio_name, "radio_name");
  gtk_widget_ref (radio_name);
  gtk_object_set_data_full (GTK_OBJECT (search_dialog), "radio_name", radio_name,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radio_name);
  gtk_table_attach (GTK_TABLE (table), radio_name, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  radio_surname = gtk_radio_button_new_with_label (search_grp_group, _("Last Name"));
  search_grp_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_surname));
  gtk_widget_set_name (radio_surname, "radio_surname");
  gtk_widget_ref (radio_surname);
  gtk_object_set_data_full (GTK_OBJECT (search_dialog), "radio_surname", radio_surname,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radio_surname);
  gtk_table_attach (GTK_TABLE (table), radio_surname, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  radio_state = gtk_radio_button_new_with_label (search_grp_group, _("State"));
  search_grp_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_state));
  gtk_widget_set_name (radio_state, "radio_state");
  gtk_widget_ref (radio_state);
  gtk_object_set_data_full (GTK_OBJECT (search_dialog), "radio_state", radio_state,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radio_state);
  gtk_table_attach (GTK_TABLE (table), radio_state, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  radio_city = gtk_radio_button_new_with_label (search_grp_group, _("City"));
  search_grp_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_city));
  gtk_widget_set_name (radio_city, "radio_city");
  gtk_widget_ref (radio_city);
  gtk_object_set_data_full (GTK_OBJECT (search_dialog), "radio_city", radio_city,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radio_city);
  gtk_table_attach (GTK_TABLE (table), radio_city, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  radio_prof = gtk_radio_button_new_with_label (search_grp_group, _("Profession"));
  search_grp_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_prof));
  gtk_widget_set_name (radio_prof, "radio_prof");
  gtk_widget_ref (radio_prof);
  gtk_object_set_data_full (GTK_OBJECT (search_dialog), "radio_prof", radio_prof,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radio_prof);
  gtk_table_attach (GTK_TABLE (table), radio_prof, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  radio_web = gtk_radio_button_new_with_label (search_grp_group, _("Web Address"));
  search_grp_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_web));
  gtk_widget_set_name (radio_web, "radio_web");
  gtk_widget_ref (radio_web);
  gtk_object_set_data_full (GTK_OBJECT (search_dialog), "radio_web", radio_web,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radio_web);
  gtk_table_attach (GTK_TABLE (table), radio_web, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  radio_mail = gtk_radio_button_new_with_label (search_grp_group, _("Mail Address"));
  search_grp_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_mail));
  gtk_widget_set_name (radio_mail, "radio_mail");
  gtk_widget_ref (radio_mail);
  gtk_object_set_data_full (GTK_OBJECT (search_dialog), "radio_mail", radio_mail,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radio_mail);
  gtk_table_attach (GTK_TABLE (table), radio_mail, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  radio_tel = gtk_radio_button_new_with_label (search_grp_group, _("Telephone"));
  search_grp_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radio_tel));
  gtk_widget_set_name (radio_tel, "radio_tel");
  gtk_widget_ref (radio_tel);
  gtk_object_set_data_full (GTK_OBJECT (search_dialog), "radio_tel", radio_tel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radio_tel);
  gtk_table_attach (GTK_TABLE (table), radio_tel, 2, 3, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  frame4 = gtk_frame_new (_(" How "));
  gtk_widget_show (frame4);
  gtk_box_pack_start (GTK_BOX (vbox), frame4, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame4), 5);

  vbox2 = gtk_vbox_new(TRUE, 0);
  gtk_container_add(GTK_CONTAINER(frame4), vbox2);
  gtk_widget_show(vbox2);

  /* check button
     search case sensitive
  */
  hbox2 = gtk_hbox_new (TRUE, 0);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox2, TRUE, TRUE, 0);  

  case_check = gtk_check_button_new_with_label (_("Case sensitive"));
  gtk_widget_set_name (case_check, "case_check");
  gtk_widget_ref (case_check);
  gtk_object_set_data_full (GTK_OBJECT (search_dialog), "case_check", case_check,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_box_pack_start (GTK_BOX (hbox2), case_check, TRUE, TRUE, 0);
  gtk_widget_show (hbox2);
  gtk_widget_show (case_check);
  /* ----------------------------------------------
     GConf --- notify check change ---
     ---------------------------------------------- */
  rubrica_preferences_configure_check(case_check, client, RUBRICA_KEY_SENSITIVE);
  rubrica_config_check_notify(case_check, client,  RUBRICA_KEY_SENSITIVE); 

  /* check button
     search in complete/incomplete string
  */    
  hbox3 = gtk_hbox_new (TRUE, 0);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox3, TRUE, TRUE, 0);  

  incomplete_check = gtk_check_button_new_with_label (_("Find an incomplete string"));
  gtk_widget_set_name (case_check, "incomplete_check");
  gtk_widget_ref (incomplete_check);
  gtk_object_set_data_full (GTK_OBJECT (search_dialog), "incomplete_check", 
			    incomplete_check, (GtkDestroyNotify) gtk_widget_unref);
  gtk_box_pack_start (GTK_BOX (hbox3), incomplete_check, TRUE, TRUE, 0);
  gtk_widget_show (hbox3);
  gtk_widget_show (incomplete_check);
  /* ----------------------------------------------
     GConf --- notify check change ---
     ---------------------------------------------- */
  rubrica_preferences_configure_check(incomplete_check, client,  
				      RUBRICA_KEY_INCOMPLETE);
  rubrica_config_check_notify(incomplete_check, client,  RUBRICA_KEY_INCOMPLETE);

  /*    Search results
   */
  frame5 = gtk_frame_new (_(" Results "));
  gtk_widget_show (frame5);
  gtk_box_pack_start (GTK_BOX (vbox), frame5, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame5), 5);

  /*    *********************************************
	Result window
	*********************************************      */
  result_window = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_name (result_window, "result_window");
  gtk_widget_ref (result_window);
  gtk_object_set_data_full (GTK_OBJECT (search_dialog), "result_window", result_window,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (result_window);
  gtk_container_add (GTK_CONTAINER (frame5), result_window);
  gtk_container_set_border_width (GTK_CONTAINER (result_window), 5);

  /*      le barre di scorrimento devono apparire solo se necessario 
   */
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (result_window), 
				  GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  /*    Clist           -- i risultati della ricerca --
  */
  search_list = gtk_clist_new (2);
  gtk_widget_set_name (search_list, "search_list");
  gtk_widget_ref (search_list);
  gtk_object_set_data_full (GTK_OBJECT (search_dialog), "search_list", search_list,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (search_list);
  gtk_container_add (GTK_CONTAINER (result_window), search_list);
  gtk_clist_set_column_width (GTK_CLIST (search_list), 0, 117);
  gtk_clist_set_column_width (GTK_CLIST (search_list), 1, 80);

  /*  I titoli della clist devono apparire solo 
      se la ricerca  positiva
  */
  gtk_clist_column_titles_show (GTK_CLIST (search_list));

  /*  Etichetta per la colonna delle schede */
  label_card = gtk_label_new (_("Card"));
  gtk_widget_show (label_card);
  gtk_clist_set_column_widget (GTK_CLIST (search_list), 0, label_card);

  /*    Etichetta per la seconda colonna, avr un titolo 
	diverso a seconda della ricerca effettuata
	Inizialmente  vuota
  */
  label_other = gtk_label_new (_("Name"));
  gtk_widget_show (label_other);
  gtk_clist_set_column_widget (GTK_CLIST (search_list), 1, label_other);

  /* inserire qui la stringa */
  hbox4 = gtk_hbox_new(TRUE, 0);
  gtk_box_pack_start (GTK_BOX (vbox), hbox4, FALSE, FALSE, 0);
  gtk_widget_show (hbox4);

  label_result = gtk_label_new (_(" Item(s) found: "));
  gtk_label_set_justify(GTK_LABEL(label_result), GTK_JUSTIFY_LEFT);
  gtk_container_add(GTK_CONTAINER(hbox4), label_result);
  gtk_widget_show(label_result);

  dialog_action_area2 = GNOME_DIALOG (search_dialog)->action_area;
  gtk_widget_show (dialog_action_area2);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area2), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (dialog_action_area2), 8);

  /*      bottone search
	  - se cliccato deve far iniziare la ricerca
   */
  gnome_dialog_append_button_with_pixmap (GNOME_DIALOG (search_dialog), _("Search"), 
					  GNOME_STOCK_PIXMAP_SEARCH);
  search_button = g_list_last (GNOME_DIALOG (search_dialog)->buttons)->data;
  gtk_widget_set_name (search_button, "search_button");
  gtk_widget_ref (search_button);
  gtk_object_set_data_full (GTK_OBJECT (search_dialog), "search_button", search_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (search_button);
  GTK_WIDGET_SET_FLAGS (search_button, GTK_CAN_DEFAULT);

  /*    bottone Close
	- se cliccato chiude la finestra di dialogo
  */
  gnome_dialog_append_button (GNOME_DIALOG (search_dialog), GNOME_STOCK_BUTTON_CLOSE);
  close_button = g_list_last (GNOME_DIALOG (search_dialog)->buttons)->data;
  gtk_widget_set_name (close_button, "close_button");
  gtk_widget_ref (close_button);
  gtk_object_set_data_full (GTK_OBJECT (search_dialog), "close_button", close_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (close_button);
  GTK_WIDGET_SET_FLAGS (close_button, GTK_CAN_DEFAULT);


  /*    Collegamento delle funzioni di callback
   */
  /*
    gtk_signal_connect (GTK_OBJECT (search_text), "activate",
    GTK_SIGNAL_FUNC (on_combo_activate),
    NULL);
  */

  /*    Callback per i bottoni toggle della finestra
   */
  gtk_signal_connect (GTK_OBJECT (radio_card), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_card_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radio_name), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_name_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radio_surname), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_surname_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radio_state), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_state_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radio_city), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_city_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radio_prof), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_prof_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radio_web), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_web_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radio_mail), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_mail_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (radio_tel), "toggled",
                      GTK_SIGNAL_FUNC (on_radio_tel_toggled),
                      NULL);

  /*    Callback per i check button
  */  
  gtk_signal_connect (GTK_OBJECT (case_check), "toggled",
                      GTK_SIGNAL_FUNC (on_case_check_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (incomplete_check), "toggled",
                      GTK_SIGNAL_FUNC (on_incomplete_check_toggled),
                      NULL);

  /*    Callback per la clist
  */
  gtk_signal_connect (GTK_OBJECT (search_list), "select_row",
                      GTK_SIGNAL_FUNC (on_search_list_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (search_list), "button_press_event",
                      GTK_SIGNAL_FUNC (on_search_list_button_press_event),
                      NULL);

  /*    Callback per i bottoni Ok e annulla
  */
  gtk_signal_connect (GTK_OBJECT (search_button), "clicked",
                      GTK_SIGNAL_FUNC (on_search_ok_clicked),
                      (gpointer) search_text);
  gtk_signal_connect (GTK_OBJECT (close_button), "clicked",
                      GTK_SIGNAL_FUNC (on_search_close_clicked),
                      (gpointer) search_dialog);
  
  gtk_signal_connect(GTK_OBJECT(search_dialog), "delete_event",
		     GTK_SIGNAL_FUNC(on_search_close_clicked), 
		     (gpointer) search_dialog);
  
  return search_dialog;
}

GtkWidget *rubrica_search_get_search_list(void)
{
  return (GtkWidget *) search_list;
}

GtkWidget *rubrica_search_get_search_text(void)
{
  return (GtkWidget *) text_history;
}

void rubrica_search_set_label_result(gchar *str)
{
  gtk_label_set_text(GTK_LABEL(label_result), str);	
}
