/*
*  Rubrica
*  file: sort.h
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _RUBRICA_SORT_H
#define _RUBRICA_SORT_H_

#include "rubrica.h"


typedef enum {
  ALFABETICO = 0,
  DATA_CREAZIONE,
  DATA_MODIFICA,
  PERSONALIZZATA
} MODO_ORDINAMENTO;

typedef enum {
  CRESCENTE = 0,
  DECRESCENTE
} TIPO_ORDINAMENTO;

typedef enum {
  SCHEDA = 0,
  NOME,
  COGNOME
} ORDINARE;

typedef struct _Ordinamento {
  MODO_ORDINAMENTO modo;
  TIPO_ORDINAMENTO tipo;
  ORDINARE campo;
} Ordinamento;

/* funzioni per l'ordinamento delle schede  */

void  rubrica_init_ordinamento(void);
void  rubrica_riordina_lista();

Ordinamento rubrica_get_ordinamento();

void  rubrica_ordinamento_set_campo(ORDINARE n);

void  rubrica_ordinamento_set_alfabetico();
void  rubrica_ordinamento_set_creation_date();
void  rubrica_ordinamento_set_modification_date();

void  rubrica_ordinamento_set_crescente();
void  rubrica_ordinamento_set_decrescente();

gint  alfa(gconstpointer a, gconstpointer b);
gint  creation_date(gconstpointer a, gconstpointer b);
gint  changing_date(gconstpointer a, gconstpointer b);

#endif











